# PathConvert

Extends \Task

Converts path and classpath information to a specific target OS format. The resulting formatted path is placed into the specified property.

Use \Project#createTask to register a new Task.

author | Siad Ardroumli siad.ardroumli@gmail.com
package | phing.tasks.system

### Methods

## constructor

    __construct()

## Create a nested MAP element

    createMap() : \MapEntry

### Response

`\MapEntry`

a Map to configure

## Create a nested PATH element

    createPath()

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Has the refid attribute of this element been set?

    isReference() : true

### Response

`true`

if refid is valid

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Apply the configured map to a path element. The map is used to convert between Windows drive letters and Unix paths. If no map is configured, then the input string is returned unchanged.

    mapElement(string $elem) : String

### Arguments

#### $elem

`string`

The path element to apply the map to

### Response

`String`

Updated element

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed()

## Perfrom this task

    perform()

inherited

throws |

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Set the default directory separator string

    setDirSep(string $sep)

### Arguments

#### $sep

`string`

directory separator string

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## Set the default path separator string; defaults to current JVM

    setPathSep(string $sep)

### Arguments

#### $sep

`string`

path separator string

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## The property into which the converted path will be placed.

    setProperty( $p)

### Arguments

#### $p

``

## Adds a reference to a Path, FileSet, DirSet, or FileList defined elsewhere.

    setRefid(\Reference $r)

throws |

### Arguments

#### $r

`\Reference`

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Set setonempty

    setSetonempty(boolean $setonempty)

If false, don't set the new property if the result is the empty string.

### Arguments

#### $setonempty

`boolean`

true or false

## Set targetos to a platform to one of "windows", "unix", "netware", or "os/2"; required unless unless pathsep and/or dirsep are specified.

    setTargetos( $target)

### Arguments

#### $target

``

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Validate that all our parameters have been properly initialized.

    validateSetup()

throws | if something is not setup properly

### Properties

## Path to be converted

    path :

### Type(s)

``

## Reference to path/fileset to convert

    refid : \Reference

var |

### Type(s)

`\Reference`

## The target OS type

    targetOS :

### Type(s)

``

## Set when targetOS is set to windows

    targetWindows :

### Type(s)

``

## Set if we're running on windows

    onWindows :

### Type(s)

``

## Set if we should create a new property even if the result is empty

    setonempty :

### Type(s)

``

## The property to receive the conversion

    property :

### Type(s)

``

## Path prefix map

    prefixMap : array<mixed,\MapEntry>

var |

### Type(s)

`array<mixed,\MapEntry>`

## User override on path sep char

    pathSep :

### Type(s)

``

## User override on directory sep char

    dirSep :

### Type(s)

``

## from

    from :

### Type(s)

``

## to

    to :

### Type(s)

``

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`